﻿Imports System
Imports System.Globalization
Imports System.Linq
Imports DevExpress.ExpressApp
Imports DevExpress.Data.Filtering
Imports DevExpress.ExpressApp.Updating
Imports Xafari.BC.Data

Public Class Updater
    Inherits ModuleUpdater
    Public Sub New(ByVal objectSpace As IObjectSpace, ByVal currentDBVersion As Version)
        MyBase.New(objectSpace, currentDBVersion)
    End Sub

    Public Overrides Sub UpdateDatabaseAfterUpdateSchema()
        MyBase.UpdateDatabaseAfterUpdateSchema()

        If ObjectSpace.GetObjects(Of FilterObject)().Count > 0 Then
            Return
        End If
        Dim i1 = 1
        While i1 <= 100
            Dim obj = ObjectSpace.CreateObject(Of Object_B)()
            obj.Name = i1.ToString(CultureInfo.InvariantCulture) + "_Object_B"
            i1 += 1
        End While
        Dim i2 = 1
        While i2 <= 100
            Dim obj = ObjectSpace.CreateObject(Of Object_C)()
            obj.Name = i2.ToString(CultureInfo.InvariantCulture) + "_Object_C"
            i2 += 1
        End While
            ObjectSpace.CommitChanges()
        Dim specificationObject1List = ObjectSpace.GetObjects(Of Object_B)().OrderBy(Function(a) a.Name).ToList()
        Dim specificationObject2List = ObjectSpace.GetObjects(Of Object_C)().OrderBy(Function(a) a.Name).ToList()
        Dim applyFilterObject1 = ObjectSpace.CreateObject(Of Object_A)()
            applyFilterObject1.Name = "1_ApplyFilterObject"
            applyFilterObject1.Object_B = specificationObject1List(0)
            applyFilterObject1.Object_C = specificationObject2List(0)
        Dim applyFilterObject2 = ObjectSpace.CreateObject(Of Object_A)()
            applyFilterObject2.Name = "2_ApplyFilterObject"
            applyFilterObject2.Object_B = specificationObject1List(0)
            applyFilterObject2.Object_C = specificationObject2List(24)
        Dim applyFilterObject3 = ObjectSpace.CreateObject(Of Object_A)()
            applyFilterObject3.Name = "3_ApplyFilterObject"
            applyFilterObject3.Object_B = specificationObject1List(14)
            applyFilterObject3.Object_C = specificationObject2List(29)
        Dim applyFilterObject4 = ObjectSpace.CreateObject(Of Object_A)()
            applyFilterObject4.Name = "4_ApplyFilterObject"
            applyFilterObject4.Object_B = specificationObject1List(79)
            applyFilterObject4.Object_C = specificationObject2List(59)
        Dim applyFilterObject5 = ObjectSpace.CreateObject(Of Object_A)()
            applyFilterObject5.Name = "5_ApplyFilterObject"
            applyFilterObject5.Object_B = specificationObject1List(0)
            applyFilterObject5.Object_C = specificationObject2List(29)


        Dim filterObject = ObjectSpace.CreateObject(Of FilterObject)()
        filterObject.Name = "FilterObject"
        filterObject.Oid = New Guid("89BAFC65-28E6-480E-9424-07157D554093")

        FilterObject.FilterObject_B.Criteria = CriteriaOperator.Parse("StartsWith([Name], '1')")
        FilterObject.FilterObject_B.SelectionType = MultipleSelectionType.Criteria
        FilterObject.FilterObject_C.SetSelectedObject(New List(Of Object_C)() From { _
            specificationObject2List(0), _
            specificationObject2List(10), _
            specificationObject2List(55) _
        })
        FilterObject.FilterObject_C.SelectionType = MultipleSelectionType.Multiple
        ObjectSpace.CommitChanges()
    End Sub

    Public Overrides Sub UpdateDatabaseBeforeUpdateSchema()
        MyBase.UpdateDatabaseBeforeUpdateSchema()
        'If (CurrentDBVersion < New Version("1.1.0.0") AndAlso CurrentDBVersion > New Version("0.0.0.0")) Then
        '    RenameColumn("DomainObject1Table", "OldColumnName", "NewColumnName")
        'End If
    End Sub
End Class